﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using C1.Chart.Test;
using System.Windows.Forms.DataVisualization.Charting;

namespace ChartBenchmark.Controls
{
    class MSChartCtrl : IChart
    {
        Chart _chart;
        PlotType _ptype = PlotType.Column;

        public MSChartCtrl()
        {
            _chart = new Chart();
            _chart.ChartAreas.Add("ChartArea");
        }

        public PlotType PlotType
        {
            get
            {
                return _ptype;
            }

            set
            {
                _ptype = value;
            }
        }

        void SetPlotType()
        {
            var ser = _chart.Series[0];
            switch (PlotType)
            {
                case PlotType.Column:
                    ser.ChartType = SeriesChartType.Column;
                    break;
                case PlotType.Line:
                    ser.ChartType = SeriesChartType.FastLine;
                    break;
                case PlotType.LineSymbols:
                    ser.ChartType = SeriesChartType.Line;
                    ser.MarkerStyle = MarkerStyle.Square;
                    break;
                case PlotType.Scatter:
                    ser.ChartType = SeriesChartType.FastPoint;
                    ser.MarkerStyle = MarkerStyle.Square;
                    break;
                case PlotType.Area:
                    ser.ChartType = SeriesChartType.Area;
                    break;
            }
        }

        public void Clear()
        {
            _chart.Series.Clear();
            _chart.DataSource = null;
        }

        public void Create(ICollection<C1.Chart.Test.DataPoint> pts)
        {
            var ser = new Series();
            ser.XValueMember = "X";
            ser.YValueMembers = "Y";
            _chart.Series.Add(ser);
            SetPlotType();
            _chart.DataSource = pts;
            _chart.Refresh();
        }

        public void Create(double[] xs, double[] ys)
        {
            throw new NotImplementedException();
        }

        public string GetInfo()
        {
            return string.Format("{0} {1}", GetName(), _chart.GetType().Assembly.GetName().Version);
        }

        public virtual string GetName()
        {
            return "MSChart";
        }

        public object GetControl()
        {
            return _chart;
        }
    }
}
